/*
 * This file is part of QCluster.
 *
 * QCluster is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * QCluster is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with QCluster; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Peter Harper <peter.harper@open-msg.com>
 *
 * $Id: clustercomms.h,v 1.1 2003/12/02 06:17:38 rmello Exp $
 */

#include "ns.h"
#include "cluster.h"

#ifndef _CLUSTERCOMMS_H
#define _CLUSTERCOMMS_H

extern void q_comms_process(struct q_server *server_ptr,
                            int msg_id, void *msg_buf, int msg_size);
extern int q_comms_send_add_msg(struct q_server  *remote_server_ptr,
                                struct q_message *msg_ptr);
extern int q_comms_send_can_process_msg(struct q_server *remote_server_ptr,
                                        struct q_group *group_ptr);
extern int  q_comms_send_delegate_msg(struct q_server *remote_server_ptr,
                                      struct q_message *msg_ptr, int cur_hops);
extern int q_comms_can_process_msg(struct q_group *group_ptr);
extern int  q_comms_distribute_msg(struct q_server *ignored_server_ptr,
                                   struct q_message *msg_ptr);
extern int  q_comms_delegate_msg(struct q_server *ignored_server_ptr,
                                 struct q_message *msg_ptr, int cur_hops);
extern int  q_comms_msg_status_update(struct q_message *msg_ptr);
extern int  q_comms_recover_server(struct q_server *failed_server_ptr);
extern int  q_comms_delete_recovered_message(struct q_server *failed_server_ptr,
                                             struct q_message *msg_ptr);
extern int  q_comms_server_connect_dump_messages(
                                          struct q_server *remote_server_ptr);

/*
 * Define the qcluster protocol message indentifiers.
 */
#define Q_MSG_TYPE_ID                   0
#define Q_MSG_TYPE_MSG_ADD              1
#define Q_MSG_TYPE_MSG_DELEGATE         2
#define Q_MSG_TYPE_MSG_STATUS_UPDATE    3
#define Q_MSG_TYPE_MSG_DELETE_RECOVERED 4
#define Q_MSG_TYPE_MSG_CAN_PROCESS      5

#endif
